#include <stdio.h>
#include <stdlib.h>
#include <sysexits.h>
#include <unistd.h>
#include <sys/syscall.h>

#define SYSCALL_SCHED_PROPOSE_MIGRATION 331

void print_usage(void)
{
    fprintf(stderr, "Usage: migration_test BINARY\n");
}

int main(int argc, char **argv)
{
    pid_t child;

    /* Check arguments */
    if (argc != 2) {
        print_usage();
        return EX_USAGE;
    }

    /* Check file existence/access */
    if (access(argv[1], X_OK) < 0) {
        fprintf(stderr, "Error: file %s not found/executable\n", argv[1]);
        return EX_NOINPUT;
    }


    child = fork();
    /* Error */
    if (child < 0) {
        fprintf(stderr, "error forking child\n");
        return -1;
    }
    /* Child -- execute popcorn binary*/
    else if (child == 0) {
        execl(argv[1], NULL);
    }
    /* Parent -- wait 1 second, then signal to migrate*/
    else {
        sleep(1);

        syscall(SYSCALL_SCHED_PROPOSE_MIGRATION, child, 1);

        wait(NULL);
    }

    return EX_OK;
}
